<?php
/**
 * Generate a color swatch.
 *
 * @project     GMapFactory
 * @revision    $Id: color.php,v 1.8.2.1 2003/09/18 02:15:35 pspencer Exp $
 * @purpose     generate a color swatch suitable to use to launch
 *              a color picker
 * @author      William A. Bronsema, C.E.T. (bronsema@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/*
 * This script generate a gif file representing
 * a color
 */

/* -------------------------------------------------------------------- */
/*      Load required modules                                           */
/* -------------------------------------------------------------------- */
if (PHP_OS == "WINNT" || PHP_OS == "WIN32")
{
    if (!extension_loaded( "gd" ))
    {
        if (!@dl( "php_gd.dll" ))
            dl("php_gd2.dll");
    }
}
else
{
    if (!extension_loaded("gd"))
    {
        if (!@dl( "php_gd.so" ))
            dl("php_gd2.so");
    }
}

//default values
$nRed = -1;
$nGreen = -1;
$nBlue = -1;
$nX = 20;
$nY = 30;

/* ============================================================================
 * HTTP_FORM_VARS array contains the HTTP GET or POST parameters
 * ========================================================================= */
$http_form_vars = count( $_POST ) > 0 ? $_POST : 
                                    ( count($_GET) > 0 ? $_GET : array("") );

//see if values were passed in
if (isset($http_form_vars['red']))
    $nRed = $http_form_vars['red'];
if (isset($http_form_vars['green']))
    $nGreen = $http_form_vars['green'];
if (isset($http_form_vars['blue']))
    $nBlue = $http_form_vars['blue'];
if (isset($http_form_vars['x']))
    $nX = $http_form_vars['x'];
if (isset($http_form_vars['y']))
    $nY = $http_form_vars['y'];

//make sure the values are valid
if ($nRed == "") $nRed = -1;
if ($nBlue == "") $nBlue = -1;
if ($nGreen == "") $nGreen = -1;

//if all values are invalid, draw an X, else adjust the colors to be valid
if ($nRed == -1 && $nGreen == -1 && $nBlue == -1)
    $bDrawX = true;
else
{
    $bDrawX = false;
    if ($nRed == -1) $nRed = 255;
    if ($nGreen == -1) $nGreen = 255;
    if ($nBlue == -1) $nBlue = 255;
}

// Create the image
$nImgId = ImageCreate($nX, $nY);

//allocate drawing colors
$nXColor = ImageColorAllocate( $nImgId, 255, 0, 0);
$nFillColor = ImageColorAllocate ($nImgId, $nRed, $nGreen, $nBlue);
$nShadowColor = ImageColorAllocate( $nImgId, 64, 64, 64 );
$nHiliteColor = ImageColorAllocate( $nImgId, 224, 224, 224 );
$nFaceColor = ImageColorAllocate( $nImgId, 192, 192, 192 );
$nTriangleColor = ImageColorAllocate($nImgId, 0,0,0);
$nWhite = ImageColorAllocate($nImgId, 255, 255, 255 );

//fill up the rectange with the face color and draw everything
//else on top
ImageFilledRectangle($nImgId, 0, 0, $nX - 1, $nY - 1, $nFaceColor);

//check if we have a valid color
if (!$bDrawX)
{
    //yes, draw the color
    ImageFilledRectangle($nImgId, 3, 3, $nX - 4, $nY - 4, $nFillColor);
}
else
{
    //no, draw a red X
    $nCX = intval(( $nX - 1 ) / 2);
    $nCY = intval(( $nY - 1 ) / 2);
    ImageFilledRectangle( $nImgId, 3, 3, $nX - 4, $nY - 4, $nWhite );
    ImageLine( $nImgId, $nCX-3, $nCY-3, $nCX+3, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX-2, $nCY-3, $nCX+4, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX+3, $nCY-3, $nCX-3, $nCY+3, $nXColor );
    ImageLine( $nImgId, $nCX+4, $nCY-3, $nCX-2, $nCY+3, $nXColor );
    
}

//draw the small face colored box for the drop down triangle
ImageFilledRectangle($nImgId, $nX-8, $nY-6, $nX-1, $nY-1, $nFaceColor);


ImageLine( $nImgId, 0, 0, $nX-1, 0, $nHiliteColor);
ImageLine( $nImgId, 0, 0, 0, $nY-1, $nHiliteColor);
ImageLine( $nImgId, $nX-1, $nY-1, $nX-1, 0, $nShadowColor);
ImageLine( $nImgId, $nX-1, $nY-1, 0, $nY-1, $nShadowColor);
ImageLine( $nImgId, 2, 2, 2, $nY - 3, $nShadowColor );
ImageLine( $nImgId, 2, 2, $nX - 3, 2, $nShadowColor );
ImageLine( $nImgId, $nX-3, 2, $nX-3, $nY-7, $nHiliteColor );
ImageLine( $nImgId, 2, $nY-3, $nX-9, $nY-3, $nHiliteColor );
ImageLine( $nImgId, $nX-9, $nY-7, $nX-3, $nY-7, $nHiliteColor );
ImageLine( $nImgId, $nX-9, $nY-7, $nX-9, $nY-3, $nHiliteColor );

$anPoints = array();
$anPoints[0] = $nX - 7;
$anPoints[1] = $nY - 5;
$anPoints[2] = $nX - 3;
$anPoints[3] = $nY - 5;
$anPoints[4] = $nX - 5;
$anPoints[5] = $nY - 3;
ImageFilledPolygon( $nImgId, $anPoints, 3, $nTriangleColor);

header("Content-type: image/png");
imagepng($nImgId);    
           

ImageDestroy($nImgId);
?>
