<?php
/**
 * MapBrowser
 *
 * @project     MapLab
 * @revision    $Id: legend.php,v 1.9.2.1 2004/07/15 19:43:07 zak Exp $
 * @purpose     This file contains supporting php functions for the
 *              legend.phtml page.
 * @author      William A. Bronsema, C.E.T. (bronsema@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

// include the globprefs file
include_once( "globprefs.php" );

// include wrapper file(s)
include_once( COMMON."wrapper/map_session.php" );

// ensure that the mapscript module is loaded
if (!extension_loaded("MapScript")) dl($gszMapscriptModule);

/* ============================================================================
 * Setup the map session class
 * ========================================================================= */
// create a new map session object
$oMapSession = new MapSession_RW;

// set the global log file and error manager
$oMapSession->setLogFile( $gLogFile );
$oMapSession->setErrorManager( $_SESSION["gErrorManager"] );

// set the temp directory for the map session
$oMapSession->setTempDir( $gszTmpMapPath );

/* ============================================================================
 * Build an array with the HTTP GET or POST parameters.
 * ========================================================================= */
$http_form_vars = (count($_POST) > 0) ? 
                  $_POST : ((count($_GET) > 0) ? $_GET : array() );


/* ============================================================================
 * Re-instate the previous map state
 * ========================================================================= */
// determine previous state key
//if ( isset( $http_form_vars["PrevStateKey"] ) )
//{
//    $szPrevStateKey = $http_form_vars["PrevStateKey"];
//    $_SESSION["gszCurrentState"] = $szPrevStateKey;
//}
//else
//    $szPrevStateKey = $_SESSION["gszCurrentState"];

// restore the previous state
$oMapSession->restoreState( $_SESSION["gszCurrentState"], $_SESSION["gszMapName"],
                                                    dirname( $_SESSION["gszMapName"] ) );

/* ============================================================================
 * Process the layer status.
 * ========================================================================= */
if ( isset($http_form_vars["NotFirstLoad"]) &&  $http_form_vars["NotFirstLoad"])
    updateLayerStatus( $oMapSession->oMap, $http_form_vars );

/* ============================================================================
 * Set the legend template.
 * ========================================================================= */
$oMapSession->oMap->legend->set( "template",
                       $gszAppPath."htdocs/mapbrowser/legend_template.html" );

/* ============================================================================
 * Process the legend template
 * ========================================================================= */
$szLegendTemplate = $oMapSession->processLegendTemplate();

/* ============================================================================
 * Save the current state.
 * ========================================================================= */
$_SESSION["gszCurrentState"] = $oMapSession->saveState();

//close the session so other pages can load now
session_write_close();

/**
 * This function updates the layer status in the map file according to the
 * user's selection in the URL.
 *
 * @param oMap object - The map object to update
 * @param szURL string - The URL to parse.
 **/
function updateLayerStatus( $oMap, $szURL )
{
    // get the list of layers
    $aszLayers = $szURL["layer_status"];

    // check if is array
    if ( !is_array( $aszLayers ) ) $aszLayers = array();

    // loop through each layer and set it's status
    for ( $i=0; $i<$oMap->numlayers; $i++ )
    {
        // create a layer object
        $oLayer = $oMap->getlayer( $i );

        // check if the name is in the URL
        if ( in_array($oLayer->name, $aszLayers) )
        {
            // set layer to ON
            $oLayer->set("status",MS_ON);
        }
        else
        {
            // set layer to OFF
            $oLayer->set("status",MS_OFF);
        }
    }
}
?>
