<?php
/**
 * remove logging operations from a file, use with standalone php
 *
 * @project     MapEdit
 * @revision    $Id: strip_log.php,v 1.6 2003/08/08 19:45:38 sacha Exp $
 * @purpose     strip logging operations.
 * @author      Paul Spencer (spencer@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2002, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

//compile the regular expressions
$reStart = "/this->log/";

$argc = $_SERVER["argc"];
$argv = $_SERVER["argv"];

$reEnd = "/\);$/";

echo "Strip Log - strip logger entries from a file by commenting them out\n";

if ( $argc != 2 )
{
    echo "usage: php ".$argv[0]." <input_file>\n";
    exit;
}

$szFile = $argv[1];
echo "copying $szFile to $szFile.bak\n";
if (!file_exists($szFile))
{
    echo "missing $szFile.\n";
    exit;
}
if (file_exists($szFile.".bak"))
{
    $szResult = readline("backup file exists, (Y) to overwrite (N) to quit: ");
    if (strcasecmp($szResult,"Y") != 0)
    {
        echo "quitting without making any changes\n";
        exit;
    }
    else
    {
        echo "removing backup file before copying\n";    
        unlink( $szFile.".bak" );
    }
}
copy( $szFile, $szFile.".bak" );

$aszFile = file($szFile);
$nChanges = 0;
$bFindEnd = false;
for($i=0;$i<count($aszFile);$i++)
{
    $szLine = $aszFile[$i];
    if (preg_match( $reStart, $szLine ))
    {
        echo "match start at $i:  $szLine\n";
        $szLine = "/* #STRIPED_LOG# ".$szLine;
        $bFindEnd = true;
        $nChanges ++;
    }
    if ($bFindEnd)
    {
        if (preg_match( $reEnd, $szLine ))
        {
            echo "match end at $i: $szLine\n";
            $szLine = substr($szLine, 0, strlen($szLine)-1)." #STRIPED_LOG# */\n";
            $bFindEnd = false;
            $nChanges ++;
        }
    }
    $aszFile[$i] = $szLine;
}

if ($nChanges > 0)
{
    echo "writing $nChanges changes to $szFile\n";
    $fp = fopen( $szFile, "w+" );
    fwrite( $fp, implode( "", $aszFile ) );
    fclose( $fp );
}

echo "done processing $szFile\n";

exit;
//read a line of input from the user
function readline( $szPrompt )
{
    echo $szPrompt;
    flush();
    exec("read var\necho \$var", $output);
    return($output[0]);
}
?>

